#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include "connexion.h"

#define PORT_FINGER 79
#define BUFFER_SIZE 1024

/* Syntaxe : client-finger nom-de-machine */
int
main (int argc, char* argv[])
{
  int sock;
  char commande[BUFFER_SIZE];
  int lu;
  char *buf;

  if (argc < 2)
    {
      fprintf (stderr, "Syntaxe : %s nom-de-machine [login]\n", argv[0]);
      exit (-1);
    }

  sock = connexion_tcp (argv[1], PORT_FINGER);
  if (sock < 0)
    {
      perror ("Erreur lors de la connexion ");
      exit (1);
    }

  if (argc < 3)
    {
      strcpy (commande, "\n");
    }
  else
    {
      sprintf (commande, "%s\n", argv[2]);
    }

  /* On envoie la commande */
  write (sock, commande, strlen (commande));
  
  /* On alloue le buffer pour la lecture des rsultats */
  buf = (char*) malloc (BUFFER_SIZE);
  if (buf == NULL)
    {
      perror ("malloc");
      exit (1);
    }

  /* On lit le rsultat */
  for ( ; ; )
    {
      lu = read (sock, buf, BUFFER_SIZE - 1);
      if (lu <= 0)
	break;
      /* On affiche */
      write (1, buf, lu);
    }

  close (sock);
  exit (0);
}

